package net.mcreator.energytutorialmod.procedures;

import net.minecraftforge.energy.CapabilityEnergy;

import net.minecraft.world.IWorld;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.Direction;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.state.DirectionProperty;
import net.minecraft.entity.item.ItemEntity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.block.BlockState;

import net.mcreator.energytutorialmod.EnergyTutorialModModElements;

import java.util.concurrent.atomic.AtomicInteger;
import java.util.Map;
import java.util.Comparator;

@EnergyTutorialModModElements.ModElement.Tag
public class FanUpdateTickProcedure extends EnergyTutorialModModElements.ModElement {
	public FanUpdateTickProcedure(EnergyTutorialModModElements instance) {
		super(instance, 2);
	}

	public static void executeProcedure(Map<String, Object> dependencies) {
		if (dependencies.get("x") == null) {
			System.err.println("Failed to load dependency x for procedure FanUpdateTick!");
			return;
		}
		if (dependencies.get("y") == null) {
			System.err.println("Failed to load dependency y for procedure FanUpdateTick!");
			return;
		}
		if (dependencies.get("z") == null) {
			System.err.println("Failed to load dependency z for procedure FanUpdateTick!");
			return;
		}
		if (dependencies.get("world") == null) {
			System.err.println("Failed to load dependency world for procedure FanUpdateTick!");
			return;
		}
		double x = dependencies.get("x") instanceof Integer ? (int) dependencies.get("x") : (double) dependencies.get("x");
		double y = dependencies.get("y") instanceof Integer ? (int) dependencies.get("y") : (double) dependencies.get("y");
		double z = dependencies.get("z") instanceof Integer ? (int) dependencies.get("z") : (double) dependencies.get("z");
		IWorld world = (IWorld) dependencies.get("world");
		if (((new Object() {
			public int getEnergyStored(BlockPos pos) {
				AtomicInteger _retval = new AtomicInteger(0);
				TileEntity _ent = world.getTileEntity(pos);
				if (_ent != null)
					_ent.getCapability(CapabilityEnergy.ENERGY, null).ifPresent(capability -> _retval.set(capability.getEnergyStored()));
				return _retval.get();
			}
		}.getEnergyStored(new BlockPos((int) x, (int) y, (int) z))) >= 50)) {
			{
				TileEntity _ent = world.getTileEntity(new BlockPos((int) x, (int) y, (int) z));
				int _amount = (int) 50;
				if (_ent != null)
					_ent.getCapability(CapabilityEnergy.ENERGY, null).ifPresent(capability -> capability.extractEnergy(_amount, false));
			}
			if (((new Object() {
				public Direction getDirection(BlockPos pos) {
					try {
						BlockState _bs = world.getBlockState(pos);
						DirectionProperty property = (DirectionProperty) _bs.getBlock().getStateContainer().getProperty("facing");
						return _bs.get(property);
					} catch (Exception e) {
						return Direction.NORTH;
					}
				}
			}.getDirection(new BlockPos((int) x, (int) y, (int) z))) == Direction.UP)) {
				if (((world
						.getEntitiesWithinAABB(LivingEntity.class,
								new AxisAlignedBB(x - 6 / 2, (y + 3) - 6 / 2, z - 6 / 2, x + 6 / 2, (y + 3) + 6 / 2, z + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, (y + 3), z))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(LivingEntity.class,
							new AxisAlignedBB(x - 6 / 2, (y + 3) - 6 / 2, z - 6 / 2, x + 6 / 2, (y + 3) + 6 / 2, z + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, (y + 3), z))).findFirst().orElse(null)).setMotion(0, 0.2,
									0);
				}
				if (((world
						.getEntitiesWithinAABB(ItemEntity.class,
								new AxisAlignedBB(x - 6 / 2, (y + 3) - 6 / 2, z - 6 / 2, x + 6 / 2, (y + 3) + 6 / 2, z + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, (y + 3), z))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(ItemEntity.class,
							new AxisAlignedBB(x - 6 / 2, (y + 3) - 6 / 2, z - 6 / 2, x + 6 / 2, (y + 3) + 6 / 2, z + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, (y + 3), z))).findFirst().orElse(null)).setMotion(0, 0.2,
									0);
				}
			} else if (((new Object() {
				public Direction getDirection(BlockPos pos) {
					try {
						BlockState _bs = world.getBlockState(pos);
						DirectionProperty property = (DirectionProperty) _bs.getBlock().getStateContainer().getProperty("facing");
						return _bs.get(property);
					} catch (Exception e) {
						return Direction.NORTH;
					}
				}
			}.getDirection(new BlockPos((int) x, (int) y, (int) z))) == Direction.DOWN)) {
				if (((world
						.getEntitiesWithinAABB(LivingEntity.class,
								new AxisAlignedBB(x - 6 / 2, (y - 3) - 6 / 2, z - 6 / 2, x + 6 / 2, (y - 3) + 6 / 2, z + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, (y - 3), z))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(LivingEntity.class,
							new AxisAlignedBB(x - 6 / 2, (y - 3) - 6 / 2, z - 6 / 2, x + 6 / 2, (y - 3) + 6 / 2, z + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, (y - 3), z))).findFirst().orElse(null)).setMotion(0,
									(-0.2), 0);
				}
				if (((world
						.getEntitiesWithinAABB(ItemEntity.class,
								new AxisAlignedBB(x - 6 / 2, (y - 3) - 6 / 2, z - 6 / 2, x + 6 / 2, (y - 3) + 6 / 2, z + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, (y - 3), z))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(ItemEntity.class,
							new AxisAlignedBB(x - 6 / 2, (y - 3) - 6 / 2, z - 6 / 2, x + 6 / 2, (y - 3) + 6 / 2, z + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, (y - 3), z))).findFirst().orElse(null)).setMotion(0,
									(-0.2), 0);
				}
			} else if (((new Object() {
				public Direction getDirection(BlockPos pos) {
					try {
						BlockState _bs = world.getBlockState(pos);
						DirectionProperty property = (DirectionProperty) _bs.getBlock().getStateContainer().getProperty("facing");
						return _bs.get(property);
					} catch (Exception e) {
						return Direction.NORTH;
					}
				}
			}.getDirection(new BlockPos((int) x, (int) y, (int) z))) == Direction.NORTH)) {
				if (((world
						.getEntitiesWithinAABB(LivingEntity.class,
								new AxisAlignedBB(x - 6 / 2, y - 6 / 2, (z - 3) - 6 / 2, x + 6 / 2, y + 6 / 2, (z - 3) + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, y, (z - 3)))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(LivingEntity.class,
							new AxisAlignedBB(x - 6 / 2, y - 6 / 2, (z - 3) - 6 / 2, x + 6 / 2, y + 6 / 2, (z - 3) + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, y, (z - 3)))).findFirst().orElse(null)).setMotion(0, 0,
									(-0.2));
				}
				if (((world
						.getEntitiesWithinAABB(ItemEntity.class,
								new AxisAlignedBB(x - 6 / 2, y - 6 / 2, (z - 3) - 6 / 2, x + 6 / 2, y + 6 / 2, (z - 3) + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, y, (z - 3)))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(ItemEntity.class,
							new AxisAlignedBB(x - 6 / 2, y - 6 / 2, (z - 3) - 6 / 2, x + 6 / 2, y + 6 / 2, (z - 3) + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, y, (z - 3)))).findFirst().orElse(null)).setMotion(0, 0,
									(-0.2));
				}
			} else if (((new Object() {
				public Direction getDirection(BlockPos pos) {
					try {
						BlockState _bs = world.getBlockState(pos);
						DirectionProperty property = (DirectionProperty) _bs.getBlock().getStateContainer().getProperty("facing");
						return _bs.get(property);
					} catch (Exception e) {
						return Direction.NORTH;
					}
				}
			}.getDirection(new BlockPos((int) x, (int) y, (int) z))) == Direction.SOUTH)) {
				if (((world
						.getEntitiesWithinAABB(LivingEntity.class,
								new AxisAlignedBB(x - 6 / 2, y - 6 / 2, (z + 3) - 6 / 2, x + 6 / 2, y + 6 / 2, (z + 3) + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, y, (z + 3)))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(LivingEntity.class,
							new AxisAlignedBB(x - 6 / 2, y - 6 / 2, (z + 3) - 6 / 2, x + 6 / 2, y + 6 / 2, (z + 3) + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, y, (z + 3)))).findFirst().orElse(null)).setMotion(0, 0,
									0.2);
				}
				if (((world
						.getEntitiesWithinAABB(ItemEntity.class,
								new AxisAlignedBB(x - 6 / 2, y - 6 / 2, (z + 3) - 6 / 2, x + 6 / 2, y + 6 / 2, (z + 3) + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, y, (z + 3)))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(ItemEntity.class,
							new AxisAlignedBB(x - 6 / 2, y - 6 / 2, (z + 3) - 6 / 2, x + 6 / 2, y + 6 / 2, (z + 3) + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq(x, y, (z + 3)))).findFirst().orElse(null)).setMotion(0, 0,
									0.2);
				}
			} else if (((new Object() {
				public Direction getDirection(BlockPos pos) {
					try {
						BlockState _bs = world.getBlockState(pos);
						DirectionProperty property = (DirectionProperty) _bs.getBlock().getStateContainer().getProperty("facing");
						return _bs.get(property);
					} catch (Exception e) {
						return Direction.NORTH;
					}
				}
			}.getDirection(new BlockPos((int) x, (int) y, (int) z))) == Direction.WEST)) {
				if (((world
						.getEntitiesWithinAABB(LivingEntity.class,
								new AxisAlignedBB((x - 3) - 6 / 2, y - 6 / 2, z - 6 / 2, (x - 3) + 6 / 2, y + 6 / 2, z + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq((x - 3), y, z))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(LivingEntity.class,
							new AxisAlignedBB((x - 3) - 6 / 2, y - 6 / 2, z - 6 / 2, (x - 3) + 6 / 2, y + 6 / 2, z + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq((x - 3), y, z))).findFirst().orElse(null)).setMotion((-0.2),
									0, 0);
				}
				if (((world
						.getEntitiesWithinAABB(ItemEntity.class,
								new AxisAlignedBB((x - 3) - 6 / 2, y - 6 / 2, z - 6 / 2, (x - 3) + 6 / 2, y + 6 / 2, z + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq((x - 3), y, z))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(ItemEntity.class,
							new AxisAlignedBB((x - 3) - 6 / 2, y - 6 / 2, z - 6 / 2, (x - 3) + 6 / 2, y + 6 / 2, z + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq((x - 3), y, z))).findFirst().orElse(null)).setMotion((-0.2),
									0, 0);
				}
			} else if (((new Object() {
				public Direction getDirection(BlockPos pos) {
					try {
						BlockState _bs = world.getBlockState(pos);
						DirectionProperty property = (DirectionProperty) _bs.getBlock().getStateContainer().getProperty("facing");
						return _bs.get(property);
					} catch (Exception e) {
						return Direction.NORTH;
					}
				}
			}.getDirection(new BlockPos((int) x, (int) y, (int) z))) == Direction.EAST)) {
				if (((world
						.getEntitiesWithinAABB(LivingEntity.class,
								new AxisAlignedBB((x + 3) - 6 / 2, y - 6 / 2, z - 6 / 2, (x + 3) + 6 / 2, y + 6 / 2, z + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq((x + 3), y, z))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(LivingEntity.class,
							new AxisAlignedBB((x + 3) - 6 / 2, y - 6 / 2, z - 6 / 2, (x + 3) + 6 / 2, y + 6 / 2, z + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq((x + 3), y, z))).findFirst().orElse(null)).setMotion(0.2, 0,
									0);
				}
				if (((world
						.getEntitiesWithinAABB(ItemEntity.class,
								new AxisAlignedBB((x + 3) - 6 / 2, y - 6 / 2, z - 6 / 2, (x + 3) + 6 / 2, y + 6 / 2, z + 6 / 2), null)
						.stream().sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq((x + 3), y, z))).findFirst().orElse(null)) != null)) {
					(world.getEntitiesWithinAABB(ItemEntity.class,
							new AxisAlignedBB((x + 3) - 6 / 2, y - 6 / 2, z - 6 / 2, (x + 3) + 6 / 2, y + 6 / 2, z + 6 / 2), null).stream()
							.sorted(Comparator.comparing(_entcnd -> _entcnd.getDistanceSq((x + 3), y, z))).findFirst().orElse(null)).setMotion(0.2, 0,
									0);
				}
			}
		}
	}
}
